/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/> for more details. 
 * Copyright (C) 2010 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "xcom.h"
#include "patcher.h"

__declspec(naked) void handleDecrementProductionNumber()
{
	__asm pusha

	static int ECXvalue, ESIvalue;
	static short mouseY;
	static short* pdesiredNum;

	__asm
	{
		//ECX and ESI store the components to the pointer to the desired production quantity.
		mov	ECXvalue, ecx
		mov	ESIvalue, esi
		
		//Get the mouse's vertical position.
		mov	mouseY, di
	}
	
	//Get the pointer to the desired number.
	pdesiredNum = (short*)(ECXvalue + ESIvalue*2 + 0x0D2);

	//Check that the mouse's position is over the right button.
	if(mouseY >= 0x83 && mouseY <= 0x91)
	{
		if((*pdesiredNum) > -2)
		{
			(*pdesiredNum)--;

			//Set the flag that indicates the button was just freshly pressed
			__asm mov [esp + 48h - 1Ch], 1
		}
	}

	__asm
	{
		popa

		//Make sure ax is set as normal.
		push esi
		push ecx
		mov ecx, ECXvalue
		mov esi, ESIvalue
		mov ax, [ecx + esi*2 + 0D2h]
		pop ecx
		pop esi

		retn
	}
}

//This function removes the check to stop production on items with -1 and -2 desired quantities set.
__declspec(naked) void jumpToProductionCompleteHandler()
{
	__asm pusha

	static short producedNum, desiredNum, itemProductType, itemBaseType, itemPurchaseType = -1;
	static int productSellPrice, baseNum;

	//Load all the values we'll need into C variables.
	__asm
	{
		mov cx, [ebp - 46h]
		mov desiredNum, cx

		mov cx, [esp + 28h]
		mov itemProductType, cx

		mov cx, [ebp + 0]
		mov producedNum, cx

		mov baseNum, ebx
	}

	//We must translate from the item product type to the item purchase type.
	itemBaseType = *(ProductDat + 14 + 18*itemProductType); //Translate from product.dat type to base.dat type
	
	//Because there's no way to directly index from a base.dat item type (to my knowledge), we need to reverse-index it
	//by iterating through purchase.dat and looking for our base.dat item type. Yes, this is slow.
	for(int i = 8; i < 91; i++)
	{
		if(*((char*)(PurchaseDat) + 1 + i * 20) == itemBaseType)
		{
			itemPurchaseType = i;

			break;
		}
	}
	if(itemPurchaseType <= -1)
	{
		//Error condition; this should never happen unless bad data is being used.
		itemPurchaseType = 0;	//Just set it to a soldier for now, since they have no sell value.
	}

	//Grab the sell price from PurchaseDat.
	productSellPrice = *((int*)((char*)(PurchaseDat) + 10 + (int)(itemPurchaseType) * 20));

	//Handle the actual production details.
	if((desiredNum > -1) && (producedNum >= desiredNum))
	{	//Stop production; we've made enough.
		__asm 
		{
			popa
			add esp, 4

			push 44188Eh
			ret
		}
	}
	else if(desiredNum == -1)
	{	//-1 means we don't want to stop production, and we want to sell the results.
		*money += productSellPrice;
		(*(int*)(((char*)(*BaseDat)) + ((char)baseNum) * 292 + 96 + (int)(itemBaseType)*2)) -= 1;
		__asm
		{
			popa
			retn
		}
	}
	else if(desiredNum <= -2)
	{	//-2 means we want an infinitely produced item, but we don't want to sell it.
		//This code is superfluous, as the 'else' below would handle it, but it is added for clarity.
		__asm
		{
			popa
			retn
		}
	}
	else
	{	//Do nothing, because we're not done producing yet.
		__asm
		{
			popa		
			retn
		}
	}
}

//Replace the -1 and -2 values in the manufacture quantity dialog window with $$$ and ***.
__declspec(naked) void drawNewManufactureQuantityDialogLabel()
{
	static int desiredNum, color, *dst, offsetX, offsetY;
	static short useSmallFont;

	__asm
	{
		//Get the arguments for the call.
		mov edx, [esp + 04h]
		mov desiredNum, edx

		mov edx, [esp + 0Ch]
		mov dst, edx

		pusha
		push esi
	}

	color = 0x0D1;
	useSmallFont = 0;

	offsetY = int(((char*)dst - *BackBuffer) / 320);
	offsetX = ((char*)dst - *BackBuffer) % 320;

	//Draw the appropriate numbers or symbols.
	if(desiredNum > -1)
	{
		DrawNumber2(desiredNum, color, offsetY, offsetX + 7, useSmallFont);
	}
	else if(desiredNum == -1)
	{
		DrawString("$$$", color, offsetY, offsetX + 7, useSmallFont);
	}
	else
	{
		DrawString("***", color, offsetY, offsetX + 7, useSmallFont);
	}

	__asm
	{
		pop esi
		popa
		retn
	}
}

//Replace the -1 and -2 quantity values with $$$ and *** on the main manufacturing screen.
__declspec(naked) void drawNewMainManufactureQuantityLabel()
{
	static int desiredNum, color, useSmallFonts;
	static short ypos, xpos;

	__asm
	{
		//Get the arguments for the call.
		push edx
		mov edx, [esp + 04h + 04h]
		mov desiredNum, edx
		mov edx, [esp + 04h + 08h]
		mov color, edx
		mov dx, [esp + 04h + 0Ch]
		mov ypos, dx
		mov dx, [esp + 04h + 10h]
		mov xpos, dx
		mov edx, [esp + 04h + 14h]
		mov useSmallFonts, edx
		pop edx

		pusha
		push esi
		push edi
	}
	
	//Draw the appropriate numbers or symbols.
	if(desiredNum > -1)
	{
		DrawNumber2(desiredNum, color, ypos, xpos, useSmallFonts);
	}
	else if(desiredNum == -1)
	{
		DrawString("$unlimited$", color, ypos, xpos-40, useSmallFonts);
	}
	else
	{
		DrawString("unlimited", color, ypos, xpos-25, useSmallFonts);
	}
	
	__asm
	{
		pop edi
		pop esi
		popa

		retn
	}
}

void drawNewManufactureDialogEntry()
{
unsigned short xpos, ypos, hours;
unsigned int days;
 
__asm
	{
	mov	xpos, ax
	mov	ypos, cx
	mov	days, edi
	mov	hours, si
	}	
								//ufo corrented   
	short quantity=*(short*)(((*(int*)0x49AAD0)+((*(short*)0x49AAC8)*350))+((*(short*)0x49AACC)*2)+0xD2); //new

if (quantity>0)
	if (days>=365)
	{
		DrawString("halting",0xDB,ypos,xpos-6,1);
	}
	else
	{
	DrawNumber2(days,0xDB,ypos,xpos,1);
	DrawString("/",0xDB,(*carretPosition),0xFFFF,1);
	DrawNumber(hours,0xDB,(*carretPosition),1);
	}
else
	{	
	DrawString("working",0xDB,ypos,xpos-6,1);
	}
}

