/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "patcher.h"
#include "xcom.h"
#include "patches.h"


static int draw_accuracy=0;
static int current_efficiency;
static int minimum_efficiency;
static int snap_penalty_distance;
static int auto_penalty_distance;
static int aimed_penalty_distance; //new

static int auto_penalty_dropoff;  //new
static int snap_penalty_dropoff;  //new
static int aimed_penalty_dropoff; //new

static int orange_cursor_limit;
static int red_cursor_limit;

void LoadAccuracyParameters()
{
	minimum_efficiency=INI_READ_INT("Range Based Accuracy","Minimum Efficiency",50);
	auto_penalty_distance=INI_READ_INT("Range Based Accuracy","Auto Penalty Distance",14);
	snap_penalty_distance=INI_READ_INT("Range Based Accuracy","Snap Penalty Distance",30);
	aimed_penalty_distance=INI_READ_INT("Range Based Accuracy","Aimed Penalty Distance",200); //new

	auto_penalty_dropoff=INI_READ_INT("Range Based Accuracy","Auto Accuracy Dropoff",2);  //new
	snap_penalty_dropoff=INI_READ_INT("Range Based Accuracy","Snap Accuracy Dropoff",2);	//new
	aimed_penalty_dropoff=INI_READ_INT("Range Based Accuracy","Aimed Accuracy Dropoff",3); //new

	orange_cursor_limit=INI_READ_INT("Range Based Accuracy","Orange Cursor Threshold",95);
	red_cursor_limit=INI_READ_INT("Range Based Accuracy","Red Cursor Threshold",75);
}

int GetEfficiency(int xpos1,int ypos1,int xpos2,int ypos2)
{
	menu_item *mi=&WeaponMenu_Items[*WeaponMenu_ClickedItem];
	int distance=GetDistance(xpos1, ypos1, xpos2, ypos2);
	int efficiency=100;
	switch(mi->actionType)
	{
		case 5://heavy laser
			if(distance>auto_penalty_distance)
			{
				//efficiency-=(distance-auto_penalty_distance);
				efficiency-=((distance-auto_penalty_distance)*auto_penalty_dropoff);

			}
			break;
		case 4: //heavy laster full auto
			if(distance>auto_penalty_distance)
			{
				//efficiency-=(distance-auto_penalty_distance);
				efficiency-=((distance-auto_penalty_distance)*auto_penalty_dropoff);

			}
			break;
		case 1://autoshot: penalty starts at 14 (7 tiles)
			if(distance>auto_penalty_distance)
			{
				//efficiency-=(distance-auto_penalty_distance);
				efficiency-=((distance-auto_penalty_distance)*auto_penalty_dropoff);

			}
			break;
		case 2://snapshot: penalty starts at 30 (15 tiles)
			if(distance>snap_penalty_distance)
			{
				//efficiency-=(distance-snap_penalty_distance);
				efficiency-=((distance-snap_penalty_distance)*snap_penalty_dropoff);

			}
			break;
		case 3://aimedshot: no distance penalty
			if(distance>aimed_penalty_distance) //new function
			{
				efficiency-=((distance-aimed_penalty_distance)*aimed_penalty_dropoff);
			}
			break;

		default:
			break;
	}

	if(efficiency<minimum_efficiency)
		efficiency=minimum_efficiency;

	return efficiency;
}

extern int firing_hl;
void DrawPCKSpriteCursorHook(__int16 a, __int16 b, int c, int d)
{
	DrawPCKSprite(a,b,c,d);

	if ( firing_hl == 0 )
	{

	//		62 -> green
	//		32 -> red
	//		16 -> orange
		current_efficiency=GetEfficiency(*currentUnit_xpos,*currentUnit_ypos,*tac_currentTile_xpos+*tac_xview,*tac_currentTile_ypos+*tac_yview);

		if(draw_accuracy)
		{
			char acc[64];
			int color=62;
			menu_item *mi=&WeaponMenu_Items[*WeaponMenu_ClickedItem];

			if(current_efficiency<orange_cursor_limit)
				color=16;
			if(current_efficiency<red_cursor_limit)
				color=32;

			int accuracy=((int)mi->accuracy*current_efficiency)/100;

//			int distance=GetDistance(*currentUnit_xpos,*currentUnit_ypos,*tac_currentTile_xpos+*tac_xview,*tac_currentTile_ypos+*tac_yview);


//			sprintf(acc,"dist=%d eff=%d acc=%d%% cor=%d%% col=%d r=%d",distance,current_efficiency,(int)mi->accuracy,((int)mi->accuracy*current_efficiency)/100,color,red_cursor_limit);
			sprintf(acc,"%d%%",accuracy);
			DrawString(acc,color,*mouse_ypos-16,*mouse_xpos-16,1);

			draw_accuracy=0;
		}
	}
}

__declspec(naked) void DrawAccuracy(void)
{
	__asm
	{
		mov draw_accuracy,1
		mov dx, word ptr ds:[0x4783A8]
		ret
	}
}

void RangeBasedAccuracy()
{
	__asm pusha

	short x1=*(short *)0x4783F8;
	short y1=*(short *)0x4783FA;
	short x2=*(short *)0x478400;
	short y2=*(short *)0x478402;
	short saved_accuracy=*accuracy;

	if( x1 == x2 && y1 == y2 ) //vertical shot
		return;

	*accuracy=(*accuracy*current_efficiency)/100;

	AdjustShotWithAccuracy();

	*accuracy=saved_accuracy;

	__asm popa
}

__declspec(naked) void CheckMainState()
{
	__asm
	{
		//cmp isDuringReactionFire, 0
		mov ecx, 0x4783E4
		cmp byte ptr [ecx], 0
			
		jnz end
		mov ecx, 0x4781DC
		cmp word ptr [ecx], 0
end:
		ret
	}
}


void ReactionFireAccuracy()
{
	__asm pusha

	int distance=GetDistance(*(short *)0x4783F8,*(short *)0x4783FA,*(short *)0x478400,*(short *)0x478402);
	int efficiency=100;

	//snapshot: penalty starts at 30 (15 tiles)
	if(distance>snap_penalty_distance)
	{
		efficiency-=(distance-snap_penalty_distance);
	}
	if(efficiency<minimum_efficiency)
		efficiency=minimum_efficiency;

	current_efficiency=efficiency;

	RangeBasedAccuracy();

	__asm popa
}

#define DOOR_COST 4

void TryToOpenDoor(int pUnitPos, int orientation)
{
	short oldFacing_y;
	short oldFacing_x;

	UpdateCurrentlyFacedTile();
	oldFacing_y=*facingTile_ypos;
	oldFacing_x=*facingTile_xpos;

	TryChangeUnitOrientation(pUnitPos, orientation);

	UpdateCurrentlyFacedTile();


	if((*currentUnit_pUnitRef)->TUs_Current>=DOOR_COST) {
		if(*facingTile_isValid&&oldFacing_y==*facingTile_ypos&&oldFacing_x==*facingTile_xpos)
		{
			sub_422B60(*currentUnit_ypos,*currentUnit_xpos,*currentUnit_zpos,*facingTile_ypos,*facingTile_xpos,orientation, (*currentUnit_pUnitRef)->MovementType);
			if(*MustGoThroughDoor)//MustGoThroughDoor
			{
				char unitref[124];
				*(short *)(0x47841A)=*facingTile_ypos;
				*(short *)(0x47841C)=*facingTile_xpos;

				//OpenFacingDoor messes with unitref data so we just back it up
				memcpy(unitref,*currentUnit_pUnitRef,124);
				OpenFacingDoor(*MustGoThroughDoor);
				memcpy(*currentUnit_pUnitRef,unitref,124);

				UpdateSeeMapAndVisibleEnemies();

				(*currentUnit_pUnitRef)->TUs_Current-=DOOR_COST;
			}
		}
	}
	else
	{
		//Not enough TUs
		*Tactical_StatusErrorMessage=1;
	}
}


/*
.text:00418780                               ; int __cdecl TacticalComputeSoldiersLightSources()
.text:00425940                               ; int __cdecl TacticalDrawMap_sub_425940()
.text:0042EA40                               ; int __cdecl ComputeVisibleAliens(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)
.text:00420D61 E8 DA DC 00 00                call    ComputeVisibleAliens
*/
void UpdateTerrain(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)
{
	ComputeVisibleAliens(xpos, ypos, zpos, orientation, distance);
	TacticalComputeSoldiersLightSources();
	UpdateSeeMapAndVisibleEnemies();
	((void (*)())0x425940)();
/*
	mov     eax, BackBuffer
lea     ecx, [eax+0B400h]
push    ecx
push    eax
push    1
call    _sub_4302A0
*/
	((void (*)(int,char *,char *))0x4302A0)(1,*BackBuffer+0xB400,*BackBuffer);
}

/*
 * Equipment screen mod
 */
void ShowEncumberance(void)
{
	int encumberance=GetUnitEncumberance(*unitIdx);
	unsigned char strength=(*currentUnit_pUnitRef)->Strength;
	unsigned char accuracy=(*currentUnit_pUnitRef)->Firing_Acc;
	unsigned char reaction=(*currentUnit_pUnitRef)->React_Current;
	unsigned char psi_strength=(*currentUnit_pUnitRef)->Psi_Strength;
	unsigned char psi_skill=(*currentUnit_pUnitRef)->Psi_Skill;

	static char weight_str[16];
	static char accuracy_str[16];
	static char reaction_str[16];
	static char psi_strength_str[16];
	static char psi_skill_str[16];
	static int init=0;
	if(init==0) {
		init=1;
		INI_READ_STRING("Text","Weight","Weight>",weight_str,16);
		INI_READ_STRING("Text","Accuracy","Accur>",accuracy_str,16);
		INI_READ_STRING("Text","Reaction","React>",reaction_str,16);
		INI_READ_STRING("Text","Psi Strength","P.Str>",psi_strength_str,16);
		INI_READ_STRING("Text","Psi Skill","P.Skill>",psi_skill_str,16);
	}

	//Draw weight stats
	DrawString(weight_str,0x40,24,245,1);
	if(encumberance>strength)
		DrawNumber(encumberance,0x20,*carretPosition,1);
	else
		DrawNumber(encumberance,0x10,*carretPosition,1);

	DrawSmallLetter('/',0x40,*carretPosition);
	DrawNumber(strength,0x30,*carretPosition,1);

	//Only draw other stats during equiping phase
	if(*tactical_mainState != 2)
	{
		DrawString(accuracy_str,0x40,32,245,1);
		DrawNumber(accuracy,0x10,*carretPosition,1);

		DrawString(reaction_str,0x40,40,245,1);
		DrawNumber(reaction,0x10,*carretPosition,1);

		//Only draw psi stats when unit has been in psi-lab
		if(psi_skill)
		{
			DrawString(psi_skill_str,0x40,48,245,1);
			DrawNumber(psi_skill,0x10,*carretPosition,1);

			DrawString(psi_strength_str,0x40,56,245,1);
			DrawNumber(psi_strength,0x10,*carretPosition,1);
		}
	}
}

/*
 * The procedure that randomizes the shots trajectory is bugged when shooting vertically.
 * We disable it when it is the case to fix the blaster bomb bug.
 */
void FixedAccuracyCompensation()
{
	short x1=*(short *)0x4783F8;
	short y1=*(short *)0x4783FA;
	short x2=*(short *)0x478400;
	short y2=*(short *)0x478402;

	if( x1 == x2 && y1 == y2 ) //vertical shot
		return;

	AdjustShotWithAccuracy();
}


/*
 * TU reservation mode
 * We save the mode when ending turn and restore it
 * before the next human turn
 */
static short savedReservedMode=0;
void SaveReserveMode()
{
	savedReservedMode=*tac_currentTUReserveMode;
}
void RestoreReserveMode()
{
	*tac_currentTUReserveMode=savedReservedMode;
}

/*
 * Draw the rank icon in the equipment screen
 */
void DrawRank(char *str, int color, __int16 ypos, __int16 xpos, int smallFont)
{
	DrawString(str,color,ypos,xpos+32,smallFont);
	char **unitref=(char **)0x4783C4;
	if((*unitref)[0]>2) //aliens have no rank icons
		return;

	int rank=(*unitref)[0x2a];
	short oldGFX=*currentGFXPackage;

	LoadGFXRessources(1);
	
	char *icon=*smokePCKRessources+*(*smokeTabRessources+20+rank);
	DrawRankIcon((int)*BackBuffer,(int)icon,32);
#if 0
	if(*mouse_num_click1&&*mouse_xpos<32&&*mouse_ypos<32)
	{
		short saved_state=*tactical_mainState;
		char fb[320*200];
		memcpy(fb,*BackBuffer,320*200);
		*mouse_num_click1=0;
		LoadGFXRessources(3);
//		ShowSoldierStats(*currentUnit_pUnitPos);
		ShowSoldierStats(*(char **)0x4783C0);

		/*
		((void (*)(int))(0x42F680))(1);
		((void (*)())(0x412C80))();

		while(!*mouse_buttons);
		{
			((void (*)())(0x42FDD0))();
		}
		
		*tactical_mainState=saved_state;
		memcpy(*BackBuffer,fb,320*200);
*/
	}
#endif
	LoadGFXRessources(oldGFX);
}


/*
 * Trigger reaction fire when units turn
 * The two functions are called when the unit's orientation change
 */

void ReactionFire1()
{
	((void (*)())(0x42DD50))();
	__asm 
	{
		pusha	
	}
	if(*isDuringReactionFire == 0)
		PerformReactionFire();
	__asm 
	{
		popa
	}
}

void ReactionFire2(int xpos, int ypos, int zpos, __int16 orientation, __int16 distance)
{
	//ComputeVisibleAliens(xpos, ypos, zpos, orientation, distance);
	  
	__asm 
	{
		call   ComputeVisibleAliens
		pusha
	}
	if(*isDuringReactionFire == 0)
		PerformReactionFire();
	__asm 
	{
		popa
	}
}

/*
 * Get the true owner of a unit after it got memory controlled
 * esi : pUnitRef
 * dl  : return value
 */
__declspec(naked) void GetOwner()
{
/*
  0: X-Com
  1: Alien
  2: Civilian
*/
	__asm
	{
		mov dl, [esi] //type of unit
		cmp dl, 3
		jle xcom
		cmp dl, 15
		je civ
		cmp dl, 16
		je civ

		mov dl, 1
		ret

	civ:
		mov dl, 2
		ret

	xcom:
		mov dl, 0
		ret
	}
}

__declspec(naked) void FireDamageRoutine()
{
	__asm
	{
		mov     dl, byte ptr ds:4781C8h
		test    dl, dl
		jnz     fireonly
		call	PropagateFire
		call	PropagateSmoke
		call	FireMakeSmoke
		call	ApplyFireSmokeDamage
		call	FadeSmokeFire
		mov     dl, byte ptr ds:4781C8h
fireonly:
		cmp     dl, 1
		jnz     skip
		call    ApplyFireSmokeDamage
		mov     dl, byte ptr ds:4781C8h
		skip:
		mov     ecx, 41319Ah //4A5FECh
		//mov		ecx, 4131A2h
		jmp		ecx
	}
}

__declspec(naked) void SmokeDamage()
{
	__asm
	{
		//mov     al, byte ptr [esi+71h]
		//test    al, al
		//jnz     skip
		mov     al, byte ptr [esi]
		cmp     al, 02
		jg      skip
		mov     eax, 429E5Dh
		jmp     eax
		skip:
		mov     eax, 429E86h
		jmp     eax
	}
}

__declspec(naked) void WoundCheck()
{
/*
3: Tank
4: Sectoid
8: Floater
11: Chryssalid                                     
13: Sectopod
14: Cyberdisc                                      
17: Zombie        
*/
	__asm
	{
		mov		ecx, dword ptr [eax+4] //unitref
		mov		cl, byte ptr [ecx]   //unit type
		cmp		cl, 3
		jz		no_wound
		cmp     cl, 4
		jz      no_wound
		cmp     cl, 8
		jz      no_wound
		cmp		cl, 0Bh
		jz		no_wound
		cmp		cl, 0Dh
		jz		no_wound
		cmp		cl, 0Eh
		jz		no_wound
		cmp		cl, 11h
		jz		no_wound
		mov		eax, 40E1B6h
		jmp		eax
	no_wound:
		mov		eax, 40E2BAh
		jmp		eax
	}
}

void MyTacticalDrawPanicMessage(int unitIdx)
{
	if(*(short *)0x478418 == 0)
		TacticalDrawPanicMessage(unitIdx);
}

void MyTactivalViewPosPanic(int ypos, int xpos, __int16 zpos)
{
	if(*(short *)0x478418 == 0)
		SetTacticalViewPos(ypos, xpos, zpos);
}

int checkPosEqual(int x1, int y1, int z1, int x2, int y2, int z2)
{
	if(x1 == x2 && y1 == y2 && z1 == z2)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

//Checks if a unit was clicked or not. For patching purposes, also checks if the same tile has been clicked twice.
int CheckIfClickedOnUnitX(short ypos, short xpos, short zpos)
{
	static int oldposx = -1, oldposy = -1, oldposz = -1;
	static DWORD oldTime = 0;
	int i;
	short result = 0;

	*clickedUnit_unitpos = *((short*)UnitposDat); //Set X-COM's clicked unit position global to UnitposDat's position.
	
	//Loop until we find a unit that is both active and matches the position clicked.
	//If we run out of unit slots to check, then run the movement confirmation code.
	for(i = 0;
		!(checkPosEqual(xpos, ypos, zpos, UnitposDat[i].xpos, UnitposDat[i].ypos, UnitposDat[i].zpos) && !(!(UnitposDat[i].flags & 2)));
		i++)
	{

		*clickedUnit_unitpos = (short)((short*)UnitposDat + i); //Update the clickedUnit_unitpos global with i
		if(i >= 80)
		{	//We didn't select a unit, so check movement confirmation against the old try.
			if(!checkPosEqual(xpos, ypos, zpos, oldposx, oldposy, oldposz))
			{	//Positions don't match; movement unsuccessful.
				oldposx = xpos, oldposy = ypos, oldposz = zpos;
				*clickedUnit_idx = *(char*)0x4781E6;
				oldTime = timeGetTime();

				return 1;
			}
			else if(oldTime > (timeGetTime() - 500)) //Give the player 500ms to click a second time.
			{	//Positions match and timer is good; movement successful.
				oldposx = -1, oldposy = -1, oldposz = -1;
				oldTime = 0;

				return 0;
			}
			else
			{	//Positions match, but timer expired; movement unsuccessful.
				*clickedUnit_idx = *(char*)0x4781E6;
				oldTime = timeGetTime();
				
				return 1;
			}
		}
	}

	if(UnitposDat[i].owner == 0)
	{	//This is an XCOM unit.
		result = 1;
		*clickedUnit_idx = (short)i;
	}
	else
	{
		if ((UnitposDat[i].flags & 1) || ((*(short*)0x478418) && *(char*)(currentUnit_pUnitPos + 9) == 1))
		{	//Don't allow selecting this (it's probably an alien or civilian).
			result = 2;
		}
		*clickedUnit_idx = (short)i;
	}

	return result;
}

void Chrys_BurstSound1()
{
	short dyingunit_uniposID; //=*(short *)0x4783EC;
	char  visible=0;

	__asm  mov	dyingunit_uniposID, cx
	
	int unitPOSref=dyingunit_uniposID*14+0x4A2C40;
	int unit_ref=*(int*)((dyingunit_uniposID*14)+0x4A2C40+4);
	char unit_type=*(char *)unit_ref;
	__asm
	{
		mov   eax, unitPOSref
		mov   cl, byte ptr [eax+0Ah]
		test  cl, 1
		jz    unseen
		mov   visible, 1
     unseen:
	}

	if (unit_type==0x11)
	{
		if (visible==1)
	{
		SoundCall(2,0x3F,0xA0);
	}
	}

	CallDeathAnimation(dyingunit_uniposID);

	if (unit_type==0x11)
	{
	Sleep_time(250);
	SoundCall(0x33,0x3F,0xA0);
	}
}

__declspec(naked) void SetZombieTimer()
{
	__asm
	{
		mov     byte ptr [eax+37h], 0Dh
		movsx   eax, [esp+48h]  //current unit UNITPOSid
		lea     ebx, ds:0[eax*8]
		sub     ebx, eax
		lea     edi, ds:4A2C40h[ebx*2]
		xor     eax,eax
		mov     ax, word ptr ds:4782A4h
		add     ax, 5
		mov     word ptr [edi+0Ch], ax
		pop     edi
		pop     esi
		mov		ebx, 4097EFh
		jmp		ebx
	}
}

void BakeChryssalid(int UNITPOSref)
{
	 int unitref=*(int*)(UNITPOSref+4);
	 short GameDiff=*(short*)0x49B85E;
	 *(char *)(unitref)=0xB;
	 *(int *)(unitref+2)=*(int*)0x4ADE98;
	 *(int *)(unitref+6)=*(int*)0x4ADE9C;
	 for (char i=0;i<6;i++)
	 {
		   *(char*)(unitref+0x3F+i)=0;
	 }
	 *(char *)(unitref+0x10)=0x46;
	 *(char *)(unitref+0x1C)=0x46;
	 *(char *)(unitref+0x26)=0x39;
	 *(char *)(unitref+0x31)=0x15;
	 *(char *)(unitref+0x32)=0x15;
	 *(char *)(unitref+0x37)=9;
	 *(char *)(unitref+0x39)=0xFF;
	 *(char *)(unitref+0x3B)=1;
	 *(char *)(unitref+0x49)=4;
	 *(char *)(unitref+0x23)=0x1E+(((0x1E*GameDiff)+5)/10);
	 for (char a=0;a<6;a++)
	 {
		   *(char *)(unitref+0x12+a)=0x22+(((0x22*GameDiff)+5)/10);
		   *(char *)(unitref+0x1D+a)=0x22+(((0x22*GameDiff)+5)/10);
	 }
	 *(char *)(unitref+0xD)=0x60+(((0x60*GameDiff)+5)/10);
	 *(char *)(unitref+0x1A)=0x60+(((0x60*GameDiff)+5)/10);
	
	for(char g=0;g<12;g++)
	{
		*(char *)(unitref+(0x56+g))=*(char *)(0x46B038+g);
	}
	__asm
	{
		mov   eax, unitref
		mov	  cl, byte ptr [eax+78h]
		or    cl, 2
		mov   byte ptr [eax+78h], cl
	}
}

void CheckZombieTimers()
{
	unsigned char UNIT=0;
	unsigned int CurrentUNIT;
	char valid, visible;
    
	while (UNIT<81)
	{
		CurrentUNIT=0x4A2C40+(UNIT*14);
		valid=0;
		visible=0;
		__asm
		{
			mov		eax, CurrentUNIT
			mov		cl, byte ptr [eax+0Ah]
			test    cl, 2
			jz		invalid
			test	cl, 4
			jnz		invalid
			test    cl, 1
			jz      unseen
			mov		visible, 1
		 unseen:
			mov		valid, 1
		invalid:
		}
		
		if (valid==1)
		{
			unsigned int CurrentUNITREF=*(int*)(CurrentUNIT+4);
		  if (*(char*)CurrentUNITREF==17)
		  {
		    // if (*(char*)(CurrentUNITREF+0x72)>0) (*(char *)(CurrentUNIT+0xC))=(*(char *)(CurrentUNIT+0xC))+1;
			 {
			 if (*(short*)(CurrentUNIT+0xC)<=*(short *)0x4782A4)
			 {
			    char  Xcomturn=0;
				__asm
				{
				movsx  ax, byte ptr ds:4782A4h //Current turn
				mov	   bx, ax
				inc    bx
				sar    ax, 1
				sar    bx, 1
				cmp    ax, bx
				jnz    end
				mov    Xcomturn, 1
				end:
				}
				if (Xcomturn==1)
				{
					if(visible==1)
						{
						SoundCall(2,0x3F,0xA0);
						CallDeathAnimation(UNIT);
						}
					BakeChryssalid(CurrentUNIT);
					Sleep_time(150);
					SoundCall(0x33,0x3F,0xA0);
					if (*(char*)(CurrentUNIT+9)!=1) *(char*)(CurrentUNIT+9)=1;
					__asm   //no exploit for mced zombie
					{
						mov   ecx, CurrentUNIT
						mov   al, byte ptr [ecx+0Ah]
						and   al, 0BFh
						mov   byte ptr [ecx+0Ah], al
					}
				}
			 }
			 }
		  }
		}
		UNIT+=1;
	}
}

__declspec(naked) void ArmorMod1()
{
	__asm
	{
		cmp		byte ptr [esi], 0Dh  //Is this a sectopod?
		jnz		skip                 //If not, bypass the following:
		cmp		word ptr ds:4783EAh, 3  //Is damage type laser?
		jnz		skip
		cmp     [esp+10h], 1  //Is impact area the head?
		jnz		nocrit
		cmp		byte ptr [esi+17h], 0
		jle		skip
		sub		byte ptr [esi+17h], 5   //subtract 5 from base fire accuracy
	nocrit:
		sub		byte ptr [esi+17h], 5
		cmp		byte ptr [esi+17h], 0
		jge     skip
		mov     byte ptr [esi+17h], 0
	skip:
		cmp		byte ptr ds:4783EAh, 5  //Is weapon damage type stun?
		jnz		skip2
		mov		eax, dword ptr ds:4781F8h  //current object's obpos memory offset into eax
		test    eax, eax
		jz      skip2
		cmp     byte ptr [eax], 1Ah //is current weapon a stun rod?
		jz		pierce
skip2:
		cmp		byte ptr [esi], 4   //Is this a sectoid?
		jz		psi
		cmp     byte ptr [esi], 6    //Is this an etheral?
		jz      psi
		cmp     word ptr ds:4783EAh, 0  //Is damage type AP?
		jz		pierce
        //standard model of damage
		mov		eax, dword ptr [esp+14h]  //mov value of current armor at location into eax
		shl		ax, 1
		cmp		cx, ax
		jg		damage
		cmp		byte ptr ds:4783EAh, 5
		jz		end1
		sub		ax, cx
		sar		ax, 1
		mov		dword ptr [esp+14h], eax
		jmp		end1
pierce:
		mov		eax, dword ptr [esp+14h]  //mov value of current armor at location into eax
		cmp		cx, ax
		jg		damage
		jmp		end1
psi:
		mov		eax, dword ptr [esp+14h]  //mov value of current armor at location into eax
		shl		ax, 1
		cmp		cx, ax
		jg		damage
		mov		eax, 40E3AAh
		jmp		eax
damage:
		sub		ecx, eax
		mov		eax, 40DF98h
		jmp		eax
end1:
		mov		eax, 40E36Fh
		jmp		eax
	}
}

__declspec(naked) void ArmorMod2()
{
	__asm
	{
		cmp	    byte ptr [esi], 4
		jz      skip
		cmp     byte ptr [esi], 6
		jz      skip
		cmp		word ptr ds:4783EAh, 0  //weapon damage type
		jnz		noarmor                  //armor gone for any other damage type
		movsx   edi, cx
		mov     eax, 51EB851Fh
		or      ebp, 0FFFFFFFFh
		lea     edx, [edi+edi*4]
		shl     edx, 1
		imul    edx
		sar     edx, 5
		mov     eax, edx
		shr     eax, 1Fh
		add     edx, eax
		mov     eax, dword ptr [esp+18h] //ArmorVar
		sub     ebp, edx
		add     eax, ebp
		test    ax, ax
		mov     dword ptr [esp+18h], eax
		jge     here
 noarmor:
		mov		dword ptr [esp+18h], 0
	here:
		mov		edx, 40DFEBh //40DFE1h
		jmp		edx
	skip:
		xor     eax,eax
		mov	    edx, 40DFEBh //40DFE1h
		jmp	    edx
	}
}

int AutopsyCheck()
{
	int pCurDamUnitPOSref=*(int *)0x4A285C;
	int	pCurShootUnitPOSref=*(int *)0x4A5FC0;
	char CurDamUnitFact=*(char *)(pCurDamUnitPOSref+9);	
	char CurShootUnitFact=*(char *)(pCurShootUnitPOSref+9);
	int pCurDamUnitUNITREFref=*(int *)(pCurDamUnitPOSref+4);
	char CurDamUnitType=*(char *)pCurDamUnitUNITREFref;	
	if (CurDamUnitFact==2 && CurShootUnitFact==1) return 1;
	if (CurDamUnitFact==0 && CurShootUnitFact==0) return 0;
	if (CurDamUnitType<=3) return 1;
	if (CurDamUnitType==17) return 0;
	if (CurDamUnitType>3 && CurDamUnitType<15)
	{
		char UnitType=CurDamUnitType-=4;
		char UnitAutopsy=*(char*)(0x46FF70+(UnitType*22));
		if (UnitAutopsy==1) return 1;
		else return 0;
	}
	else return 0;
}

__declspec(naked) void DamageMod()
{
	__asm
	{
		cmp		word ptr ds:4783EAh, 2 //Is it HE damage?
		jz		fulldamage
		mov     eax, dword ptr [esp+10h] //Impact spot
		cmp     al, 1        
		jz		fulldamage   //Hit the "head" or other vital spot.
		call 	AutopsyCheck
		test	al, al
		jnz     fulldamage
		sar     ecx,1
		fulldamage:
		mov     al, byte ptr [esi+0Dh]
		xor     dx, dx
		mov     dl, al
		cmp     dx, cx
		jg      loc_40E120
		mov		edx, 40DFFCh
		jmp     edx
	loc_40E120:
		mov     edx, 40E120h
		jmp     edx
	}
}

__declspec(naked) void StunMod()
{
	__asm
	{
	mov   eax, edi
	cdq
	and   edx, 3
	//cmp   word ptr ds:4783EAh, 0
	//jnz   skip
	xor   eax, eax
	//skip:
	add   eax, edx
	ret
	}
}

__declspec(naked) void BaseTankLoadFix()
{
	__asm
	{
		mov     ebx, edx
		xor		edx, edx
    	cmp     word ptr ds:4A3EB4h, 2  //Is this a base defense misssion
		jnz		skip
		cmp     ax, 2
		jz      noammo
		cmp     ax, 3
		jz      noammo
		mov     edi, [esp+1Ch]  //current base memory offset
		cmp     ax, 1
		jz      rockets
		cmp     ax, 4
		jz      bbombs
		and     eax, 0Fh
		xor     ecx, ecx
		mov     ecx, [esp+10h] //number of remaining tanks to spawn
		mov     ax, word ptr[edi+11Ah]
		idiv    cx
		cmp     ax, 1Eh
		jle		nocap
		mov     ax, 1Eh
	nocap:
		mov     [ebp+76h], al
		sub     word ptr [edi+11Ah], ax
		jmp     end
	rockets:
		xor     eax, eax
		xor		ecx, ecx
		movsx   ecx, byte ptr [esp+10h] //number of remaining tanks to spawn
		movsx   eax, word ptr [edi+11Ch]
		idiv    ecx
		cmp     ax, 8
		jle		nocap1
		mov     ax, 8
	nocap1:
		mov     [ebp+76h], al
		sub     word ptr [edi+11Ch], ax
		jmp     end
	bbombs:
		and     eax, 0Fh
		xor     ecx, ecx
		mov     ecx, [esp+10h] //number of remaining tanks to spawn
		mov     ax, word ptr[edi+11Eh]
		idiv    cx
		cmp     ax, 8
		jle		nocap2
		mov     ax, 8
	nocap2:
		mov     [ebp+76h], al
		sub     word ptr [edi+11Eh], ax
		jmp     end 
skip:    

		test    ax, ax
		jnz     loc_44ED2D
		mov     byte ptr [ebp+76h], 1Eh
		jmp     end
		loc_44ED2D:
		cmp     ax, 2
		jz      noammo
		cmp     ax, 3
		jz      noammo
		mov     byte ptr [ebp+76h], 8
		jmp     end
noammo: 
		mov     byte ptr [ebp+76h], 0FFh
	end:
		mov     edx, ebx
		mov     ebx, dword ptr ds:49B954h //pointer to SOLDIER.DAT offset
		xor     eax, eax
		mov     edi, 44ED37h
		jmp     edi
	}
}


__declspec(naked) void TankStats()
{
	__asm
	{
		mov		cl, [ebp+2Eh]
		cmp		cl, 2
		jnz		standard
		mov		ecx, 11C106h
		shl		ecx, 2    
		mov		cl, byte ptr [ecx]
		cmp		cl, 58h
		jnz		standard
		mov     [ebp+12h], 6Eh
		mov     [ebp+1Dh], 6Eh
		mov     [ebp+13h], 5Fh
		mov     [ebp+1Eh], 5Fh
		mov     [ebp+14h], 5Fh
		mov     [ebp+1Fh], 5Fh
		mov     [ebp+15h], 5Ah
		mov     [ebp+20h], 5Ah
		mov     [ebp+16h], 5Ah
		mov     [ebp+21h], 5Ah
		mov     cl, [eax+9]
		mov     [ebp+17h], cl
		mov     cl, [ebp+0Ch]
		mov     [ebp+19h], cl
		mov     cl, [ebp+0Dh]
		mov     [ebp+1Ah], cl
		mov     cl, [ebp+0Fh]
		mov     [ebp+1Bh], cl
		mov     cl, [ebp+10h]
		mov     [ebp+1Ch], cl
		jmp		end
	standard:
		mov     cl, [eax+0Ch]
		mov     [ebp+12h], cl
		mov     cl, [eax+0Dh]
		mov     [ebp+13h], cl
		mov     cl, [eax+0Eh]
		mov     [ebp+14h], cl
		mov     cl, [eax+0Fh]
		mov     [ebp+15h], cl
		mov     cl, [eax+10h]
		mov     [ebp+16h], cl
		mov     cl, [eax+9]
		mov     [ebp+17h], cl
		mov     cl, [ebp+0Ch]
		mov     [ebp+19h], cl
		mov     cl, [ebp+0Dh]
		mov     [ebp+1Ah], cl
		mov     cl, [ebp+0Fh]
		mov     [ebp+1Bh], cl
		mov     cl, [ebp+10h]
		mov     [ebp+1Ch], cl
		mov     cl, [eax+0Ch]
		mov     [ebp+1Dh], cl
		mov     cl, [eax+0Dh]
		mov     [ebp+1Eh], cl
		mov     cl, [eax+0Eh]
		mov     [ebp+1Fh], cl
		mov     cl, [eax+0Fh]
		mov     [ebp+20h], cl
		mov     cl, [eax+10h]
		mov     [ebp+21h], cl
	end:
		ret
	}
}


__declspec(naked) void ZombieMCFix()
{
	__asm
	{
		mov     ebx, [eax+0Ah]
		or 		ebx, 2
		and		ebx, 3
		mov     [eax+0Ah], ebx
		cmp     [esp+44h+8], 1 //NewUnitType 1=zombie
		jz		skip
		mov		[eax+26h], 39h
	skip:
		mov		ebx, 40964Ch
		jmp		ebx
	}
}

__declspec(naked) void ChrysFix()
{
	__asm
	{
		mov     byte ptr [eax], 0Bh
		mov     ecx, dword ptr ds:4ADE98h
		mov     [eax+2], ecx
		mov     byte ptr [eax+26h], 39h
		mov     ecx, 4096FFh
		jmp     ecx
	}
}

__declspec(naked) void LargeUnitMCFix()
{
	__asm
	{
		mov		dl, byte ptr ds:4781C8h //tactical side var
		mov		ecx, [eax+0Ah]
		test    ecx, 4   //test for large unit
		jz      single        //finish for small units 
		mov		ecx, 4A2C40h  //start of UNITPOSref
		xor		esi, esi
findheadloop:               //find the first section or "head" of the large unit selected
		mov		edx, dword ptr [ecx+4]
		cmp		dword ptr [eax+4], edx
		jz		finish
		add		ecx, 0Eh
		inc		esi
		cmp		esi, 50h
		jge		end
		jmp		findheadloop
finish:
		xor		esi, esi
MCloop:  
		mov		edx, dword ptr[ecx+0Ah]
		or      edx, 40h
		mov		dword ptr[ecx+0Ah], edx
		mov		byte ptr [ecx+9], 0
		inc     esi
		cmp		esi, 4
		jge		end
		add     ecx, 0Eh
		jmp		MCloop
single:
		or      ecx, 40h
		mov		[eax+0Ah], ecx
		mov		byte ptr [eax+9], dl
end:
		mov		edx, 41F0C6h
		jmp		edx
	}
}

__declspec(naked) void LargeUnitExplosionFix()
{
	__asm
	{
		call    Tactical_DoDamageToUnit
		add     esp,8
		xor		ecx, ecx
		xor		edx, edx
		xor		eax, eax
		mov		ecx, dword ptr [edi+9]
		test    ecx, 4
		jz      single
		shl		ecx, 3
		and     ecx, 3
		mov		edx, 3
		sub		edx,ecx
		mov		eax, [esp+14h]
		add		eax, edx
		mov		[esp+14h],eax
		mov		eax, dword ptr [edi+9]
		test    eax, 2
		jnz		skip
		mov		eax, 0FFFFFFFDh
		lea		esi,ds:0[ecx*8]
		sub		esi, ecx
		neg		esi
		mov		ecx, dword ptr [edi+esi*2+9]
		lea		esi, [edi+esi*2-1]
		and		ecx, eax
		mov		dword ptr [esi+0Ah], ecx
		mov		ecx, dword ptr[esi+18h]
		and		ecx, eax
		mov		dword ptr [esi+18h], ecx
		mov		ecx, dword ptr[esi+26h]
		and		ecx, eax
		mov		dword ptr [esi+26h], ecx
		mov		ecx, dword ptr [esi+34h]
		and		ecx, eax
		mov		dword ptr [esi+34h],ecx
	skip:
		lea		esi,ds:0[edx*8]
		sub		esi,edx
		lea		edi,[edi+esi*2]
	single:
		mov		eax, 40D010h
		jmp		eax
	}
}	

__declspec(naked) void BezerkCrashFix()
{
	__asm
	{
			push    2
			call    GetRandomNum
			add     esp, 4
			inc     al
			cmp     al, 3
			jnz     skip
			cmp     byte ptr [esi+75h], 0FFh
			jnz     skip
			cmp     byte ptr [edi+0Ah], 4
			jz      skip
			mov     al, 2
			skip:
			mov     edi, 41F376h
			jmp     edi
	}
}

__declspec(naked) void FixDoorJam(void)
{
//.text:0041B97B 02 DA                         add     bl, dl
//.text:0041B97D 88 58 2E                      mov     [eax+structMCDData.openedDoorTile], bl

	__asm
	{
		add     bl, dl
		mov     [eax+46], bl

		cmp [eax+0x1E],1 //sliding door
		jnz skip
		push ebx
		push esi 

		and ebx,0xff

		mov esi, ebx
		shl esi, 5
		sub esi, ebx
		shl esi, 1

		mov byte ptr [esi+0x4A924F],1 //mcd "keycode"

		pop esi
		pop ebx
skip:
		ret
	}
}


__declspec(naked) void TerrorScoreFix()
{
	__asm
	{
		xor    ecx, ecx
		xor    edx, edx
		xor    ebx, ebx
		movzx  ebx, word ptr ds:478454h  //civ killed aliens
		add    ebx, dword ptr [esp+14h]  //num living civ
		add    bx, word ptr ds:478456h  //civ killed xcom
		test   ebx, ebx
		jz     skip
		mov    eax, 3F0h
		idiv   ebx
		mov    ebx, eax
		movzx  ecx, dword ptr [esp+14h]
		mov    word ptr ds:4A3ED2h, cx
		imul   ecx
		mov    word ptr ds:4A3ED4h, ax
		neg    ebx
		mov    eax, ebx
		movzx  ecx, word ptr ds:478454h
		mov    word ptr ds:4A3ECAh, cx
		imul   ecx
		mov    word ptr ds:4A3ECCh, ax
		mov    eax, ebx
		movzx  ecx, word ptr ds:478456h
		mov    word ptr ds:4A3ECEh, cx
		imul   ecx
		mov    word ptr ds:4A3ED0h, ax
skip:
		mov    ecx, 4A5FE0h
		mov    edx, 0AAh
		mov    ebx, 8
		mov    esi, 2
		mov    eax, 414C5Ah
		jmp    eax
	}
}

__declspec(naked) void AlienAttackBaseFix()
{
	__asm
	{
		test    ax, ax
		jnz     check4tile
		mov     ecx, dword ptr ds:4BA3C8h //targetPOS
		test    byte ptr [ecx+0Ah], 2
		jz      end
		mov     edx, 40307Dh
		jmp     edx
		check4tile:
		mov     edx, 4032DFh
		jmp     edx
end:
		mov     edx, 403308h
		jmp     edx
	}
}


__declspec(naked) void GrenadeStrTestFix()
{
	__asm
	{
		mov    eax, esi
		dec    eax
		cmp    eax, 0
		jg     skip
		mov    ax, 1
	skip:
		mov    word ptr ds:47843Ah, ax  
		mov    ecx, 42BD35h
		jmp    ecx
	}
}

__declspec(naked) void BombAirlock()
{
	__asm
	{
		call   SpawnUnitsOnMap
		cmp   	word ptr ds:4A3EB4h, 2
		jnz   	skip
		movsx 	edx, liftypos
		movsx 	ebx, liftxpos
		test  	edx, edx
		jz    	skip
		test  	ebx, ebx
		jz    	skip
		push    0
		mov     eax, 0B4h
		push    0Ah
		push    2
		push    eax             ; damage
		push    1         
		push    edx             ; y
		push    ebx            ; x
		mov     byte ptr ds:477EB4h, 1  //IsUPSexplosion
		call    GenerateExplosion
		add     esp, 1Ch
		mov     byte ptr ds:477EB4h, 0
		movsx 	edx, liftypos
		movsx 	ebx, liftxpos
		push    1 //0
		mov     eax, 1Eh
		push    0Ah
		push    2
		push    eax             ; damage
		push    0         
		push    edx             ; y
		push    ebx            ; x
		mov     byte ptr ds:477EB4h, 1  //IsUPSexplosion
		call    GenerateExplosion
		add     esp, 1Ch
		mov     byte ptr ds:477EB4h, 0
		skip:
		xor    eax, eax
		xor    edx, edx
		mov    esi, 41B2F8h
		jmp    esi
	}
}


/*
unsigned char *fogMap=NULL;

void Fog(short a, short b, unsigned int c, unsigned int d)
{
	((void (*)(int,int,int,int))(0x430950))(a,b,c,d);

	if(!fogMap)
		return;

	unsigned char *pSeeMapCurrentTile=*(unsigned char **)0x49DB08;

	int offset=pSeeMapCurrentTile-*pSeeMap;
	unsigned char *pFogMap=fogMap+offset;

	FILE *log=fopen("C:/log.txt","a+");
//	if(*pSeeMapCurrentTile!=0&&*pSeeMapCurrentTile!=7)
//	fprintf(log,"0x%08x 0x%08x\n",pSeeMapCurrentTile,*pSeeMapCurrentTile);
	char *buf=*BackBuffer+a+320*b;

	if(*pFogMap!=*pSeeMapCurrentTile)
	{
		//fprintf(log,"0x%08x 0x%08x\n",a,b);
		//*pSeeMapCurrentTile&=~1;
		for(int i=0;i<32;i++)
		{
			if(i+a>=320)
				continue;
			if(i+a<0)
				continue;

			for(int j=0;j<40;j++)
			{
				if(j+b>=*(int *)0x4A2848)
					continue;
				if(j+b+40<*(int *)0x4A2826)
					continue;
				
				int offset=i+a+(j+b)*320;
				if(offset>=0&&offset<64000)
					if((i+j)&1)
						*(buf+i+j*320)=0;
			}
		}
	}
	fclose(log);
}

void UpdateFogMap()
{
	int size=*map_numTilesPerLevel**tac_mapZSize;
	fogMap=(unsigned char *)realloc(fogMap,size);

	for(int i=0;i<size;i++)
	{
		fogMap[i]=(*pSeeMap)[i]|0x10;
	}
}

void ClearSeeMap()
{
	int size=*map_numTilesPerLevel**tac_mapZSize;
if(fogMap)
	for(int i=0;i<size;i++)
	{
		(*pSeeMap)[i]=0;
	}
}

void UpdateSeeMap()
{
	int size=*map_numTilesPerLevel**tac_mapZSize;
if(fogMap)
	for(int i=0;i<size;i++)
	{
		if((*pSeeMap)[i]!=0)
		{
			fogMap[i]=(*pSeeMap)[i];
		}
		else
		{
			(*pSeeMap)[i]=fogMap[i]&0x7;
		}
	}
}

//.text:0042DD87 E8 44 00 00 00                call    UpdateSeeMap
void HookSeeMap(int xpos, int ypos, __int16 zpos, int facing, int distance)
{
	ClearSeeMap();
	((void (*)(int,int,__int16,int,int))(0x42DDD0))(xpos,ypos,zpos,facing,distance);
	UpdateSeeMap();
}




//.text:0042A703 38 1D D8 B6 46 00             cmp     byte_46B6D8, bl
__declspec(naked) void FixSeeMap(void)
{
	__asm
	{
		pusha
		call UpdateSeeMap
		popa
		mov ebx, 0x46B6D8
		cmp[ebx],0
		mov ebx,0
		ret
	}
}
*/