/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "xcom.h"
#include "patcher.h"
#include "patches.h"

/*
 * Detect successful ground assault missions and trigger reaction from alien
 */
void RetaliationAfterGroundAssault(void *dstbuf, int filename)
{
	char victoryStatus;
	LoadFile(dstbuf,filename);
	victoryStatus=tac_misdata[0x4e];

	if(victoryStatus == 1) //mission successful
	{
		char locIdx=tac_misdata[0x4c];
		if( ((*locationList+20*locIdx))[0] == 1 ) //Landed UFO have type 1 here, not 6!!!
		{
			char ufoIdx=(*locationList+20*locIdx)[1];
			char craftIdx=tac_misdata[0x4d];
			void *attacker=(void *)(*craftList+104*craftIdx);
			void *ufo=(void *)(*craftList+104*ufoIdx);
			AlienTakeActionAfterShootDown(ufo,attacker);
		}
	}
}

/*
 * Wreck analysis
 * Each navigation module can provide zone and/or mission data
 * The probability may need some tweaking
 */
void WreckAnalysis(int number, int color, __int16 ypos, __int16 xpos, int useSmallFonts)
{
	DrawNumber2(number, color, ypos, xpos, useSmallFonts);

	int recoveredNavigation=tac_misdata[2];
	int i;
	int discoverZone=0;
	int discoverMission=0;
	char buf[256];
	char format[256];

#ifndef NDEBUG
	discoverZone=1;
	discoverMission=1;
#endif

	char victoryStatus=tac_misdata[0x4e];
	char missionDescriptor=tac_misdata[0x14];

	//Only work on successful ground missions
	if(victoryStatus != 1 && missionDescriptor != 0 )
		return;

	//"analyze" each navigation module
	for(i=0;i<recoveredNavigation;i++)
	{
		if(GetRandomNum(100)<20-*difficultyLevel*2)
		{
			discoverZone=1;
		}
		if(GetRandomNum(100)<20-*difficultyLevel*2)
		{
			discoverMission=1;
		}
	}


	char locIdx=tac_misdata[0x4c];
	char ufoIdx=(*locationList+20*locIdx)[1];
	int type=(*craftList+104*ufoIdx)[28];
	int zone=(*craftList+104*ufoIdx)[30];
	int race=(*craftList+104*ufoIdx)[36];
	
	char *missionName=StringTable_geoscape[558+type];
	char *zoneName=StringTable_geoscape[543+zone];
	char *raceName=StringTable_geoscape[466+race];


	if(discoverMission&&discoverZone)
	{
		INI_READ_STRING("Text","Both Discovered","Ship investigation revealed that the %s UFO was on an %s mission in %s",format,256);
		sprintf(buf,format,raceName,missionName,zoneName);
	}
	else if(discoverMission)
	{
		INI_READ_STRING("Text","Mission Discovered","Inspection showed that the %s UFO was on an %s mission",format,256);
		sprintf(buf,format,raceName,missionName);
	}
	else if(discoverZone)
	{
		INI_READ_STRING("Text","Zone Discovered","Intel found out that the %s UFO was raiding %s",format,256);
		sprintf(buf,format,raceName,zoneName);
	}
	else
	{
		return;
	}

	*DrawText_rightBorder=320-16;
	DrawString(buf,0x8b,ypos+16,16,1);
}

/*
 * Elerium ships have a constant consumption rate of 1 (for standard ship, consumption is based on ship speed).
 * This rate is used at 2 places: to know when the ship has burnt half its fuel, and to determine how much distance
 * it can still fly. The second part is buggy however and uses the standard ship formula so we end up with a fly distance
 * of 0 and the ship returns immedialty. This should fix the issue.
 */
__declspec(naked) void EleriumShipFix()
{
	__asm
	{
		mov eax,edi
		cdq
		
		cmp bl,0
		jz std_fuel
		cmp bl,3
		jz std_fuel
		ret
std_fuel:
		idiv ecx
		ret
	}
}

void CreateInitialAlienBases(__int16 isInitialBase)
{
	CreateXComBase(1);
	int nBases=INI_READ_INT("Mod","Initial Alien Bases",0);
	for(int i=0;i<nBases;i++)
	{
		unsigned char race=GetRandomNum(4);
		unsigned char zone=GetRandomNum(11);
		CreateAlienBase(zone,race);
	}
}

int HasSoldierFought(__int16 soldierIdx)
{
	unsigned char *unitpos=(unsigned char *)0x4A2C40;

	for(int i=0;i<80;i++,unitpos+=14)
	{
		if(unitpos[0]==0xff)
			continue;
//		unitref_dat *unitref=*(unitref_dat **)&unitpos[4];
		unitref_dat *unitref=&((*file_missdat_uniref_dat)[i]);
		if(unitref->soldier_index==soldierIdx)
			return 1;
	}
	return 0;
}

int GetScoreForPromotion(__int16 soldierIdx)
{
	int score=0xffffffff;
	if(HasSoldierFought(soldierIdx))
		score=GetSoldierScoreForPromotion(soldierIdx);

	return score;
}

__int64 freq = -1;

void DrawFPSGeo()
{
	static __int64 last, now;
	static int frames;
	static int fps;
	frames++;

	if(freq == -1)
	{
		QueryPerformanceFrequency((LARGE_INTEGER *)&freq);
		QueryPerformanceCounter((LARGE_INTEGER *)&last);
		return;
	}
	
	QueryPerformanceCounter((LARGE_INTEGER *)&now);

	double time=(double)(now-last)/(double)(freq);
	if(time>=1.0)
	{
		fps = frames;
		frames = 0;
		last = now;
	}

	DrawNumber2(fps, 0xf5, 1, 1, 1);
}


char ShowCraftReadyBox_title[64];
char ShowCraftReadyBox_info[64];
void ShowCraftReadyBox_Strings()
{
	static int init = 0;

	if(init == 1)
		return;

	INI_READ_STRING("Text","Title","Aircraft ready",ShowCraftReadyBox_title,63);
	INI_READ_STRING("Text","Info","A craft has been refitted",ShowCraftReadyBox_info,63);

	init = 1;
}

void ShowCraftReadyBox_Impl(unsigned char *pCraft)
{
	char craftName[64]="Unknown craft";
	const char *craftType=StringTable_geoscape[0x239+pCraft[0]];
	unsigned char baseLoc = pCraft[26];
	unsigned char baseIdx=(*locationList+20*baseLoc)[1];
	char *baseName=(char *)&(*pBaseList+292*baseIdx)[0];
	unsigned char craftIdx=(pCraft-*craftList)/104;

	for(unsigned char i=0;i<50;i++)
	{
		unsigned char type=(*locationList+20*i)[0];
		if(type!=2)
			continue;
		unsigned char craftRef=(*locationList+20*i)[1];
		if(craftRef==craftIdx)
		{
			unsigned short suffix=(*locationList+20*i)[0xa];
			sprintf(craftName,"%s-%d",craftType,suffix);
			break;
		}
	}

	ShowCraftReadyBox_Strings();

	(*geo_num_rearming_crafts)--;

	//Craft background
	LoadGeographBackScreen(14);
	LoadGeodataBackPalette(4);

	//Draw box
	((void (*)(int,int,int,int,int,int,int,int,int,int))(0x43D8C0))(0x5a,0x70,0x14,0x20,0x30,0x18,0x78,0xD0,0x14,0x86);

	DrawString(ShowCraftReadyBox_title,0x86,0x38,0x30,0);
	DrawString(ShowCraftReadyBox_info,0x86,0x48,0x30,1);

	DrawString(StringTable_geoscape[0x109],0x86,0x52+6,0x30,1); //CRAFT
	DrawDottedLine(0x86,0x82+6,1);
	DrawString(craftName,0x8B,0x52+6,0x82,1);

	DrawString(StringTable_geoscape[0x10B],0x86,0x5a+6,0x30,1); //BASE
	DrawDottedLine(0x86,0x82+6,1);
	DrawString(baseName,0x8B,0x5a+6,0x82,1);
/*
	DrawString(roswel_terrain,0x86,0x62,0x30,1);
	DrawDottedLine(0x86,0x82,1);
	DrawString(terrain,0x8B,0x62,0x82,1);
*/
	*ui_numButtons=0;

	//"Centre + 5sec" button
	CreateButton(0x80,0x30,0x0C,0xA0,0x86,StringTable_geoscape[48]);

	//Cancel
	CreateButton(0x90,0x30,0x0C,0xA0,0x86,StringTable_geoscape[49]);

	((void (*)(int))(0x42F680))(1);

	WaitTilMouseButtonsAreReleased();
	int button;
	while(!(button=CheckForClickedButton()));

	*ui_numButtons=0;


	if(button==1)
	{
		*geo_timeSpeed=1;
		RotateGlobeToLocation(baseLoc);
	}
}

__declspec(naked) void ShowCraftReadyBox()
{
	__asm {
		pusha
		push esi
		call ShowCraftReadyBox_Impl
		pop esi
		popa
		ret
	}
}

signed int __cdecl geoDrawDateTimePanel()
{
	//The position of the upper left corner of the geoscape date/time panel.
	const int baseX = 259;
	const int baseY = 74;

	char* backBufPtr;
//	signed int result;

	backBufPtr = *BackBuffer;

	BlitToBackBuffer((int)*((int*)file_geograph_geobord_scr));

	//Draw our current funds (The entire purpose of this patch!)
	DrawString("$", 245, baseY, baseX, 1);
	DrawNumber2(*(money), 245, baseY, baseX + 6, 1);

	//Draw the hours.
	if ( *(geo_currentHour) >= 10 )
	{
		DrawNumber2(*(geo_currentHour), 245, baseY + 11, baseX + 10, 1);
	}
	else
	{
		DrawNumber2(*(geo_currentHour), 245, baseY + 11, baseX + 14, 1);
	}

	//Draw the first colon.
	DrawString(":", 245, baseY + 11, baseX + 21, 1);

	//Draw the minutes.
	if ( *(geo_currentMinute) >= 10 )
	{
		DrawNumber2(*(geo_currentMinute), 245, baseY + 11, baseX + 24, 1);
	}
	else
	{	//Draw the leading zero.
		DrawString("0", 245, baseY + 11, baseX + 24, 1);
		DrawNumber2(*(geo_currentMinute), 245, baseY + 11, baseX + 29, 1);
	}

	//Draw the second colon.
	DrawString(":", 245, baseY + 11, baseX + 35, 1);

	//Draw the seconds.
	if ( *(geo_currentSecond) >= 10 )
	{
		DrawNumber2(*(geo_currentSecond), 245, baseY + 11, baseX + 38, 1);
	}
	else
	{	//Draw the leading zero.
		DrawString("0", 245, baseY + 11, baseX + 38, 1);
		DrawNumber2(*(geo_currentSecond), 245, baseY + 11, baseX + 43, 1);
	}

	//Draw the long-form day name.
	*(DrawText_leftBorder) = baseX + 30;
	DrawString(StringsTable_geoscape[*(geo_currentDayOfTheWeek) + 184], 245, baseY + 19, 0, 1);

	//Draw the day number.
	DrawNumber2(*(geo_currentDay), 245, baseY + 27, baseX + 3, 1);

	//We don't want to draw the 'st', 'nd', or 'th', because it takes up too much space.

	/*if ( *(geo_currentDay) == 1 || *(geo_currentDay) == 21 || *(geo_currentDay) == 31 )
	{
		DrawString(StringsTable_geoscape[169], 245, 101, 270, 1);
	}
	else if( *(geo_currentDay) == 2 || *(geo_currentDay) == 22 )
	{
		DrawString(StringsTable_geoscape[170], 245, 101, 270, 1);
	}
	else if ( *(geo_currentDay) == 3 || *(geo_currentDay) == 23 )
	{
		DrawString(StringsTable_geoscape[171], 245, 101, 270, 1);
	}
	else
	{
		DrawString(StringsTable_geoscape[172], 245, 101, 270, 1);
	}*/

	//Draw the short-form month name.
	DrawString(languageStuff_geoscape[month_names_index[(*geo_currentMonth)]], 245, baseY + 27, baseX + 16, 1);

	//Draw the year.
	*(DrawNumber2_useThousandSeparator) = 0;
	DrawNumber2((unsigned __int16)(*geo_currentYear), 245, baseY + 27, baseX + 36, 1);
	*(DrawNumber2_useThousandSeparator) = 1;

	//The following switch and for loop handle drawing the depressed button on the panel.
	if(INI_READ_INT("Video","Slow Geoscape Clock",0)==1)
	{
		switch ( (*geo_timeSpeed) ) 
		{ 	//Get the screen offset in the backbuffer to the button we're going to work on
		case 1:		//5 secs
			backBufPtr = (char *)backBufPtr + 112 * 320 + 257;
			break;
		case 10:	//1 min
			backBufPtr = (char *)backBufPtr + 112 * 320 + 289;
			break;
		case 30:	//5 min
			backBufPtr = (char *)backBufPtr + 126 * 320 + 257;
			break;
		case 120:	//30 min
			backBufPtr = (char *)backBufPtr + 126 * 320 + 289;
			break;
		case 300:	//1 hour
			backBufPtr = (char *)backBufPtr + 140 * 320 + 257;
			break;
		case 3600:	//1 day
			backBufPtr = (char *)backBufPtr + 140 * 320 + 289;
			break;
		}
	}
	else 
	{
		switch ( (*geo_timeSpeed) ) 
		{ 	//Get the screen offset in the backbuffer to the button we're going to work on
		case 1:		//5 secs
			backBufPtr = (char *)backBufPtr + 112 * 320 + 257;
			break;
		case 12:	//1 min
			backBufPtr = (char *)backBufPtr + 112 * 320 + 289;
			break;
		case 60:	//5 min
			backBufPtr = (char *)backBufPtr + 126 * 320 + 257;
			break;
		case 360:	//30 min
			backBufPtr = (char *)backBufPtr + 126 * 320 + 289;
			break;
		case 720:	//1 hour
			backBufPtr = (char *)backBufPtr + 140 * 320 + 257;
			break;
		case 17280:	//1 day
			backBufPtr = (char *)backBufPtr + 140 * 320 + 289;
			break;
		}
	}

	//Draw the depressed button by iterating over each pixel and shifting the colors.
	for(int i = 0; i < 13; i++)
	{
		for(int j = 0; j < 31; j++)
		{
			backBufPtr[320*i + j] = -15 - backBufPtr[320*i + j];
		}
	}

	return 0;
}

void ShowMoney()
{
	InsertCall(0x440831, geoDrawDateTimePanel);
	InsertCall(0x440F4A, geoDrawDateTimePanel);
	InsertCall(0x45A61A, geoDrawDateTimePanel);
	InsertCall(0x45A67E, geoDrawDateTimePanel);
}

__declspec(naked) void MedicResearchFix()
{
	__asm
	{
		loc_445213:
			movzx   bp, byte ptr [eax-8]
			cmp     bp, si
			jnz     loc_445232
			cmp     word ptr [eax-6], 64h
			jge     loc_445232
			test    byte ptr [eax], 2
			jnz     loc_445232
			movsx   ebp, dx
			inc     edx
			mov     byte ptr [esp+ebp+8], cl
		loc_445232:
			inc     ecx
			add     eax, 0Ch
			cmp     cx, 74h
			jl      loc_445213
			pop     esi
			pop     ebp
			test    dx, dx
			jz      skip
			movsx   eax, word ptr ds:49B1B8h //current month
			add     word ptr 49AA80h[eax*2], 32h
			dec     edx
			push    edx
			call    GetRandomNum
			and     eax, 0FFFFh
			add     esp, 4
			movzx   cx, byte ptr [esp+eax]
			movsx   eax, cx
			lea     eax, [eax+eax*2]
			movzx   edx, byte ptr 4731F8h[eax*4]
			or      edx, 2
			cmp     dword ptr [esp+30h], 2 //arg 4
			mov     byte ptr 4731F8h[eax*4], dl
			jnz     skip
			mov     edx, 445286h
			jmp     edx
		skip:
			mov     edx, 44528Fh
			jmp     edx
	}
}

__declspec(naked) void VaryRetaliationShip()
{
	__asm
	{
		cmp    word ptr ds:49B880h[eax*4], 0FFh
		jz     hammer
		cmp    word ptr ds:49B1B8h, 2
		jg     midterm
		mov    edx, 8
		jmp    end
	midterm:
		cmp    word ptr ds:49B1B8h, 6
		jg     lateterm
		push   64h
		call   GetRandomNum
		add    esp, 4
		and    eax, 0FFh
		cmp    eax, 32h
		jg     lateterm
		mov    edx, 0Ah
		jmp    end
	lateterm:
		mov    edx, 0Bh
		jmp    end
	hammer:
		mov    edx, 0Ch //0Bh
		mov    word ptr [edi+63h], 80h
		mov    cx, 0E700h
	end:
		mov    eax, 4318A5h
		jmp    eax
	}
}

__declspec(naked) void HammerFall()
{
	__asm
	{
		movsx   eax, byte ptr [ebp+0]
		lea     edx, ds:0[eax*8]
		sub     edx, eax
		mov     ax, word ptr ds:46F9AEh[edx*4]
		cmp     byte ptr [ebp+63h], 80h
		jnz     skip
		and     eax, 0FFFFh
		shl     eax, 3
		skip:
		mov     word ptr [ebp+0Eh], ax
		mov     edx, 4577E0h
		jmp     edx             //loc_4577E0
	}
}

__declspec(naked) void HammerFall2()
{
	__asm
	{
		cmp     byte ptr [ebp+63h], 80h
		jnz     skip
		mov     word ptr [ebp+0Ch], 4
		jmp     end
	skip:
		test    ax, ax
		mov     word ptr [ebp+0Ch], ax
		jnz     end
		mov     word ptr [ebp+0Ch], 1
	end:
		mov     eax, 4577AAh
		jmp     eax
	}
}



__declspec(naked) void BaseHammer()
{
	__asm
	{
		mov     eax, esi
		lea     edx, [eax+eax*4]
		mov     eax, dword ptr ds:49AAB0h //pLoc_Dat
		movzx   eax, byte ptr [eax+edx*4+1]
		lea     edx, [eax+eax*2]
		lea     eax, [eax+edx*4]
		mov     edx, dword ptr ds:49AB18h  //pCraft.dat
		lea     edx, [edx+eax*8]
		cmp     byte ptr [edx+63h], 80h
		jnz     checkbase
		push    19h
		push    3Fh
		push    0Ah
		call    SoundCall
		push    32h
		call    Sleep_time
		add     esp, 10h	
		push    18h
		push    3Fh
		push    0Ah
		call    SoundCall
		push    32h
		call    Sleep_time
		add     esp, 10h
		push    19h
		push    3Fh
		push    0Ah
		call    SoundCall
		push    32h
		call    Sleep_time
		add     esp, 10h
		push    18h
		push    3Fh
		push    0Ah
		call    SoundCall
        add     esp, 0Ch
		push    0Fh
		call    LoadGeographBackScreen
		push    8
		call    LoadGeographBackPalette
		push    86h
		mov     esi, 0A0h //esi, 
		push    100h
		push    0A0h
		push    20h
		push    14h
		call    DrawDialogBox
		mov     eax, dword ptr ds:47B2B8h
		push    0
		push    50h
		push    40h
		push    86h
		push    eax
		mov     eax, 45797Ah //457942h
		jmp     eax
		checkbase:
		mov     dx, word ptr [ebp+10h]
		push    edx
		mov     eax, 457913h
		jmp     eax
	}
}

__declspec(naked) void HammerCheck()
{
	__asm
	{
		cmp    word ptr ds:49B85Eh, 0  //game difficulty
		jz     easy
		mov    ecx, [esp+10h] //curObjectOffsetAdd
		mov    ebx, dword ptr ds:49AAB0h //pLoc_Dat
		movzx   dx, byte ptr [ecx+ebx+0Fh]  //unused byte in Loc.dat
		mov    bx, 4
		sub    bx, dx
		cmp    word ptr ds:49B85Eh, bx  //if #base attacks>=(4-game difficulty), 
		jg     doomclock
		movsx  ecx, ax
		mov    byte ptr ds:49B880h[ecx+4], 0xFF
		jmp    next
		doomclock:
		mov    ecx, [esp+10h] //+curObjectOffsetAdd]
		mov    ebx, dword ptr ds:49AAB0h //pLoc_Dat
		mov    dl, byte ptr [ecx+ebx+0Fh]
		inc    dl
		mov    byte ptr [ecx+ebx+0Fh], dl
		jmp    next
		easy:
		movsx  ecx, ax
		mov    byte ptr ds:49B880h[ecx+4], 0    
		next:
		mov    ebx, 447A7Dh
		jmp    ebx
	}
}

__declspec(naked) void AlienBaseScoreFix()
{
	__asm
	{
		movzx   ecx, word ptr ds:49B85Eh  //game diff
		cmp     cx, 0
		mov     edx, 5
		jmp     skip
		movzx   eax, word ptr ds:49B1B8h //current month
		xor     edx, edx
		imul    ecx
		mov     edx, eax
		and     edx, 0FFFFh
		xor     eax, eax
		skip:
		push    edx
		mov     dx, [esi+4]
		mov     ax, [esi+2]
		mov     ecx, 441DB0h
		jmp     ecx
	}
}
