/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/> for more details. 
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "xcom.h"
#include "patcher.h"
#include "video.h"

void PatchD3D(int hq4x);


void FixPitch(unsigned char *src);
int screen_width = 0;
int screen_height = 0;
int mouse_scaling = 0;

float vwratio,vhratio;

bool GameCursorLocked=0;
bool WindowFocused=1;

void LimitFPS()
{
	static DWORD last;
	static DWORD period;

	if(last==0)
	{
		int fps=INI_READ_INT("Video","Max FPS",0);

		if(fps!=0)
		{
			period=(int)((1.0/(float)fps)*1000.0);
		}
		else
			period=0;

		last=timeGetTime();
		return;
	}
	if(period==0)
		return;


	DWORD now=timeGetTime();
	DWORD delta=now-last;

	//Sleep is not good enough, we must busy loop
	while(delta<period)
	{
		now=timeGetTime();
		delta=now-last;
	}
	last=now;
}

void LockCursor()
{
	//if(INI_READ_INT("Video","D3D",0) && INI_READ_INT("Video","D3D Windowed",0) && INI_READ_INT("Video","Clip Cursor",0))
	if(INI_READ_INT("Video","Clip Cursor",0))
	{
		GameCursorLocked = 1;   //new
		HWND hWnd = *(HWND *)0x479B60;
		int mwidth, mheight;   //new
		RECT rc, Crc;
		GetWindowRect(hWnd, &rc);
		GetClientRect(hWnd, &Crc);

		int Titlethick=(rc.bottom - rc.top) - (Crc.bottom - Crc.top);
		int Borderthick=((rc.right - rc.left) - Crc.right)/2;

		rc.top=rc.top + Titlethick - Borderthick;
		rc.left=rc.left + Borderthick;
		//rc.bottom=rc.bottom - Borderthick;
		//rc.right=rc.right - Borderthick;
		//new section
		if(mouse_scaling) 
		{
			mwidth=(int)(screen_width*vwratio);
			mheight=(int)(screen_height*vhratio);
		}
		else //Fixes mouse going offscreen if Scale Mouse = 0
		{
			mwidth=320;
			mheight=200;
		}
		
		rc.right=rc.left + mwidth;  //new
		rc.bottom=rc.top + mheight; //new

		if (WindowFocused) //Don't confine mouse if alt+tabbed out --new
		{                  //
		ClipCursor(&rc);
		}                  //
	}//end new section
}

void SaveWindowPosition()
{
	HWND hWnd = *(HWND *)0x479B60;

	if(IsIconic(hWnd)==FALSE && IsZoomed(hWnd)==FALSE)
	{
		int height, width;
		RECT rcWindow;
		RECT rcClient;
		GetWindowRect(hWnd, &rcWindow);
		GetClientRect(hWnd, &rcClient);
		
		height=rcClient.bottom-rcClient.top; 
		width=rcClient.right-rcClient.left;
		char buf[64];
		//sprintf(buf,"%d %d %d %d",rcWindow.top,rcWindow.left,height,width);
		//WritePrivateProfileStringA("Video","D3D Window Position",buf,INI_FILE);
		sprintf(buf,"%d %d",rcWindow.left,rcWindow.top);
		WritePrivateProfileStringA("Video","D3D Window Position",buf,INI_FILE);
		sprintf(buf,"%d",width);
		WritePrivateProfileStringA("Video","D3D Window Width",buf,INI_FILE);
		sprintf(buf,"%d",height);
		WritePrivateProfileStringA("Video","D3D Window Height",buf,INI_FILE);
	}
}

void SetScreenSize(int /*width*/, int /*height*/)
{
	RECT rcClient;
	HWND hWnd = *(HWND *)0x479B60;

	//mouse_scaling = 1;

	GetClientRect(hWnd, &rcClient);

	screen_width = rcClient.right;
	screen_height = rcClient.bottom;

	void GetPolyCoord(float *vwratio, float *vhratio);  //new
	GetPolyCoord(&vwratio,&vhratio);					//new
}

//new adds here
void UnlockCursorTemp()
{
	WindowFocused=0;
	ClipCursor(NULL);
}

void UnlockCursor()
{
	GameCursorLocked=0;
	ClipCursor(NULL);
}

void ReLockCursor()
{
	WindowFocused=1;
	if (GameCursorLocked)
	{
		LockCursor();
	}
}
//end new adds

int ScaleMouse() //__declspec(naked) void ScaleMouse()
{
	RECT rcClient;
	HWND hWnd = *(HWND *)0x479B60;
	GetClientRect(hWnd, &rcClient);

	screen_width = rcClient.right;
	screen_height = rcClient.bottom;

	if(mouse_scaling)
	{
		*mouse_xpos = (int)((double)*mouse_xpos*320.0/(double)screen_width);
		*mouse_ypos = (int)((double)*mouse_ypos*200.0/(double)screen_height);
		if(*mouse_xpos > 320) *mouse_xpos = 320;
		if(*mouse_ypos > 200) *mouse_ypos = 200;
	}
	
	__asm xor eax, eax
	
	return 16;
}

//new add here
int PatchMouse() //Points to Scale or Lock depending on what's set
{	
	//Note - cursor locking is normally called in patches.cpp depending on battescape/geoscape, but for fullscreen we're turning it on forever here
	if (INI_READ_INT("Video","Scale Mouse",0) || INI_READ_INT("Video","D3D Windowed",0)) //Mouse should always be scaled in Windowed to match Windows cursor
	{
		mouse_scaling=1;
		ScaleMouse();
	}
	if (INI_READ_INT("Video","Clip Cursor",0)) //Mouse should always be locked to game window in fullscreen
	{
		LockCursor(); 
	}
	return 16;
}
//end new add

void BlitHQ4x(unsigned char *src);
extern "C"
{
int InitLUTs(void);
void hq4x_32( unsigned char * pIn, unsigned char * pOut, int Xres, int Yres, int BpL );
}

typedef unsigned char scale2x_uint8;
void scale2x_8_def(scale2x_uint8* dst0, scale2x_uint8* dst1, const scale2x_uint8* src0, const scale2x_uint8* src1, const scale2x_uint8* src2, unsigned count);

IDirectDrawSurface *pDrawingSurface;

void CreateSurface()
{
	DDSURFACEDESC ddsd;
	IDirectDraw *pDD=*(IDirectDraw **)0x4785FC;

	memset(&ddsd, 0, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);

	ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT ;
	ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
	ddsd.ddsCaps.dwCaps |= DDSCAPS_SYSTEMMEMORY;

	ddsd.dwWidth = 1280;
	ddsd.dwHeight = 800;
	SetScreenSize(1280, 800);

    ZeroMemory (&ddsd.ddpfPixelFormat, sizeof (DDPIXELFORMAT));
    ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
    ddsd.ddpfPixelFormat.dwFlags= DDPF_RGB;
    ddsd.ddpfPixelFormat.dwRGBBitCount = 32;
    ddsd.ddpfPixelFormat.dwRBitMask    = 0x00FF0000;
    ddsd.ddpfPixelFormat.dwGBitMask    = 0x0000FF00;
    ddsd.ddpfPixelFormat.dwBBitMask    = 0x000000FF;



	HRESULT nRet = pDD->CreateSurface(&ddsd, &pDrawingSurface, NULL);

}


void SetScalingMethod(int method)
{
	switch(method)
	{
		case 1:
			InsertJmp(0x42FF10,FixPitch);
			break;
		case 2: //BlitHQ4x
			{
				/*
				.text:0045C61C A1 FC 85 47 00                mov     eax, pDirectDraw
				.text:0045C621 6A 08                         push    8                               ; DWORD
				.text:0045C623 68 C8 00 00 00                push    200                             ; DWORD
				.text:0045C628 68 40 01 00 00                push    320                             ; DWORD
				.text:0045C62D 8B 08                         mov     ecx, [eax+IDirectDraw.lpVtbl]
				.text:0045C62F 50                            push    eax                             ; This
				.text:0045C630 FF 51 54                      call    [ecx+IDirectDraw3Vtbl.SetDisplayMode]
				*/
//				char bpp[]={8};
				short monitor_height = (short)GetSystemMetrics(SM_CYSCREEN);
				short monitor_width = (short)GetSystemMetrics(SM_CXSCREEN);
/*
				FILE *f=fopen("c:/log.txt","a+");
				fprintf(f, "%d %d", monitor_width, monitor_height);
				fflush(f);
				fclose(f);
*/
				char bpp[]={32};
//				short width[]={monitor_width};
//				short height[]={monitor_height};
				PatchInPlace(0x45C621+1,bpp,1);
				PatchInPlace(0x45C623+1,&monitor_height,2);
				PatchInPlace(0x45C628+1,&monitor_width,2);

				InsertJmp(0x42FF10,BlitHQ4x);

				char ret[] = {0xC3};
				PatchInPlace(0x45C7E0,ret,1);

				InsertCall(0x45C6B6,CreateSurface);
				InsertJmp(0x45C6B6+5,(void *)0x45C71D);

				InitLUTs();
			}
			break;
		case 3: //D3D
			{
				PatchD3D(0);
			}
			break;
		case 4: //D3D + HQ4x
			{
				PatchD3D(1);
			}
			break;
	}

#ifdef NDEBUG
//	if(INI_READ_INT("Video","Scale Mouse",0) || (INI_READ_INT("Video","D3D",0) && INI_READ_INT("Video","D3D Windowed",0)))
  InsertJmp(0x45E142, PatchMouse);
#endif
//	{
//		InsertJmp(0x45E142, ScaleMouse);
//	} 
}

/*
 * Fix the garbled screen problem by taking into account the surface's pitch
 */
void FixPitch(unsigned char *src)
{
	if(unsigned char *dst=DD_SurfaceLock())
	{
		IDirectDrawSurface *pSurface=*(IDirectDrawSurface **)0x478604;
		DDSURFACEDESC SurfaceDesc;
		SurfaceDesc.dwSize=sizeof(SurfaceDesc);

		pSurface->GetSurfaceDesc(&SurfaceDesc);
		int pitch=SurfaceDesc.lPitch;

		for(int i=0;i<200;i++)
		{
			memcpy(dst,src,320);
			dst+=pitch;
			src+=320;
		}

		DD_SurfaceUnlock();
		DD_SurfaceFlip();
	}
	LimitFPS();
}

void BlitHQ4x(unsigned char *src)
{
	DDSURFACEDESC ddsd;
	memset(&ddsd, 0, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);

	if(SUCCEEDED(pDrawingSurface->Lock(NULL,&ddsd,DDLOCK_WAIT,NULL)))
	{
		unsigned char *dst=(unsigned char *)ddsd.lpSurface;

		IDirectDrawSurface *pScreenSurface=*(IDirectDrawSurface **)0x478604;
		IDirectDrawSurface *pSurface=pDrawingSurface;
		
		DDSURFACEDESC SurfaceDesc;
		SurfaceDesc.dwSize=sizeof(SurfaceDesc);

		pSurface->GetSurfaceDesc(&SurfaceDesc);
		int pitch=SurfaceDesc.lPitch;

		static unsigned short image16bpp[320*200];
		for(int i=0;i<320*200;i++)
		{
			unsigned char r = palette[src[i]].r >>3;
			unsigned char g = palette[src[i]].g >>2;
			unsigned char b = palette[src[i]].b >>3;
			image16bpp[i] = (r << 11) + (g << 5) + b;
		}
		
		hq4x_32( (unsigned char *)image16bpp, (unsigned char *)dst, 320, 200, pitch );

		pDrawingSurface->Unlock(NULL);
		
		pScreenSurface->Blt(NULL,pSurface,NULL,0x01000000,NULL);
		//pScreenSurface->Blt(NULL,pSurface,NULL,NULL,NULL);
		DD_SurfaceFlip();
	}
	LimitFPS();
}
